import java.util.Scanner;

public class MainOregonTrail {

    /* The Oregon Trail was taken by settlers of the American West to get from
     * Missouri to the West Coast, at Oregon.
     * The trail was approximately 2150 miles.
     * And on average it took 5 months to complete.
     * On a good day, without any problems, 15 miles a day could be covered.
     * But....
     *
     * The Oregon Trail video game ranks as one of the all time played
     * educational games.
     *
     * All role playing (RPG) games to this day basically work the same way.
     */

    //To see how the Oregon Trail plays:
    //https://www.retrogames.cz/play_687-DOS.php

    //Your job is to continue the game, throwing in more regular random events
    //like bad weather and illness,
    //along with decisions you have to make along the way, due to both
    //these random events, and other regular situations that occur along the way
    //such as running low on food and either hunting or buying more supplies

    static String profession = "not set yet";
    static double money = 0.0;
    static int health = 100;
    static int numOxen = 0;
    static int numWagonWheels = 0;
    static double poundsOfFood = 0.0;
    static double daysOnTrail = 0.0;
    static String [] settlers = new String[4];
    static String leaderName = "not set yet";
    static String monthLeft = "not set yet";
    static double milesCoveredSoFar = 0.0;



    public static void main(String[] args) {


        settlers[0] = "not set yet";
        settlers[1] = "not set yet";
        settlers[2] = "not set yet";
        settlers[3] = "not set yet";

        Scanner snr = new Scanner(System.in);
        System.out.println("You may:");
        System.out.println("1. Travel the trail. (Type the number 1.)");
        System.out.println("2. See high scores.");
        String whatToDo = snr.nextLine();
        if(whatToDo.equalsIgnoreCase("1")){
            travelTheTrail();
        }
        else if(whatToDo.equalsIgnoreCase("2")){
            seeHighScores();
        }
        else{
            endGameCondition("need to start again");
        }
    }

    public static void travelTheTrail(){
        addSettlers();
        chooseDepartureMonth();
        buySupplies();
        //otherSetupStuff();


        while(milesCoveredSoFar < 2150) {
            Scanner snr = new Scanner(System.in);
            System.out.println("Are you ready for another weeek on the trail? true/false");
            boolean ready = snr.nextBoolean();
            if(ready) {
                anotherWeekOnTheTrail();
            }
        }
    }


    public static void anotherWeekOnTheTrail(){
        daysOnTrail += 7;
        double milesCoveredThisWeek = 0.0;
        milesCoveredThisWeek = 7 * 15;
        milesCoveredThisWeek -= possibleAccident();
        milesCoveredThisWeek -= possibleWeatherDelay();
        milesCoveredThisWeek -= possibleIllness();
        milesCoveredSoFar += milesCoveredThisWeek;
        if(daysOnTrail > 150){
            System.out.println("Sorry, winter has set in");
        }
        if(milesCoveredSoFar > 2150){
            System.out.println("Welcome to Oregon!!!!");
        }
    }

    public static double possibleAccident(){
        double daysLost = 0.0;
        if(profession.equalsIgnoreCase("Banker")){
            if(Math.random() < 0.5){
                System.out.println("Oh dear, you just had an accident.");
                System.out.println("You have lost two days in your journey repairing your wagon :-(");
                daysLost += 2;
            }
            else{
                System.out.println("Phew, no accidents this week, even for a banker!!! ;-/");
            }
        }
        else if(profession.equalsIgnoreCase("Carpenter")){
            if(Math.random() < 0.33333){
                System.out.println("Oh dear, you just had an accident.");
                System.out.println("You have lost half a day in your journey repairing your wagon :-(");
                daysLost += 0.5;
            }
            else{
                System.out.println("Phew, no accidents this week, even for a carpenter!!! ;-/");
            }
        }
        else if(profession.equalsIgnoreCase("Farmer")){
            if(Math.random() < 0.05){
                System.out.println("Oh dear, you just had an accident.");
                System.out.println("You have lost half a day in your journey repairing your wagon :-(");
                daysLost += 1;
            }
            else{
                System.out.println("Phew, no accidents this week; no wondery, you're a farmer!!");
            }
        }
        return daysLost * 15;
    }

    public static int possibleWeatherDelay(){

        return 0;
    }

    public static int possibleIllness(){

        return 0;
    }



    public static void buySupplies(){
        Scanner snr = new Scanner(System.in);
        System.out.println("Welcome to Matt's General Store");
        System.out.println("How many oxen do you want to buy ($40 each)");
        numOxen = snr.nextInt();
        money -= (numOxen * 40);


        //same thing with wagonWheels (10)
        System.out.println("How many wagon wheels do you want to buy? ($10 each)");
        numWagonWheels = snr.nextInt();
        money -= (numWagonWheels * 10);

        //same thing with food (0.50 per pound)
        System.out.println("How much food do you want to buy? (.50 cents a pound)");
        poundsOfFood = snr.nextDouble();
        money -= (poundsOfFood * 0.5);

        System.out.println("You have " + money + " left.");
        System.out.println("Thanks for shopping at Matt's General Store");
        System.out.println("Have a great trip!");

    }

    //make buySupplies() method
    //make another Scanner
    //sout something like "Welcome to Matt's General Store"





    public static void chooseDepartureMonth(){
        Scanner snr = new Scanner(System.in);
        System.out.println("What month do you want to leave? Type April, May, or June");
        monthLeft = snr.nextLine();
    }




    public static void addSettlers(){
        Scanner snr = new Scanner(System.in);
        System.out.println("Many kinds of people made the trip to Oregon.");
        System.out.println("You may:");
        System.out.println("1. Be a banker from Boston");
        System.out.println("2. Be a carpenter from Ohio");
        System.out.println("3. Be a farmer from Illinois");
        String choice = snr.nextLine();

        //assign money to be the following:
        //banker: 1600
        //carpenter: 700
        //farmer: 300
        if(choice.equalsIgnoreCase("1")){
            profession = "banker";
            money = 1600;
        }
        else if(choice.equalsIgnoreCase("2")){
            profession = "carpenter";
            money = 700;
        }
        else if(choice.equalsIgnoreCase("3")){
            profession = "farmer";
            money = 300;
        }
        else{
            endGameCondition("need to start again");
        }

        //ask the user the names of the settlers in the party
        //take them in one at a time, and assign them to settlers[0] settlers[1] etc.
        System.out.println("Who is the first settler?");
        settlers[0] = snr.nextLine();
        System.out.println("Who is the next settler?");
        settlers[1] = snr.nextLine();
        System.out.println("Who is the next?");
        settlers[2] = snr.nextLine();
        System.out.println("And who is the last settler heading off on the trip?");
        settlers[3] = snr.nextLine();
    }












    public static void seeHighScores(){

    }

    public static void endGameCondition(String theEndOfGameReason){
        if(theEndOfGameReason.equalsIgnoreCase("need to start again")){
            System.out.println("Sorry you need to start again.");
        }
    }

}
